//----------------------------------------------------------------------
// Virtuelle Basisklasse fuer ein Datenmodell
//----------------------------------------------------------------------

#include <stdio.h>
#include <qwidget.h>
#include "model.h"

void model::add_view( viewer *w )
{
//  printf("eine View eines Models erzeugen\n");
  views.append(w);			// einfach an die Liste anhaengen
  w->model_changed();				// nur diesen View neuzeichenen, denn das Model hat sich nicht geaendert
}

void model::del_view( viewer *w )
{
  views.removeRef(w);
//  printf("eine View eines Models entfernen\n");
}

void model::change( void )
{
  viewer *w;
  for ( w=views.first(); w != 0; w=views.next() )
  {
    w->model_changed();
  }
//  printf("ein Model hat sich geaendert, Views benachrichtigen\n");
}

void viewer::model_changed( void )
{
  printf("Ein Model hat die Methode <model_changed> nicht ueberladen!\n");
}

