//---------------------------------------------------------------------
// Dieses Objekt ist der viewer fuer ein Akkuobjekt
#ifndef akku_draw_included
#define akku_draw_included

#include <qframe.h>
#include <qpaintd.h>
#include <qwidget.h>
#include "akku.h"
#include <drag.h>

class akku_draw : public QFrame, public viewer, public KDNDDropZone
{
//  Q_OBJECT
  public:

  akku_draw(QWidget *q, const char *c) : QFrame(q,c) , KDNDDropZone(this,DndURL)
  {
     moreinit();
  };

  void moreinit( void );
  void moredelete( void );

  void paintEvent( QPaintEvent * );
  void set_akku( akku_model *a);
  void del_akku( void );
  void draw_window( QPaintDevice * );
  void print( QPrinter * );
  void set_referenz_akku( akku_model *ak );
  void del_referenz_akku( void );
  void model_changed( );

  void drop( char *_data, int _size, int _type, int _x, int _y );

  private:
    akku_model *a;	// dieses Modell wird angezeigt
    akku_model *r;	// das ist der optionale Referenzakku (in gruen)
} ;

#endif
