//----------------------------------------------------------------------------
// Klasse fuer die Abfrage und Verwaltung des Ladegeraetes
//----------------------------------------------------------------------------

#ifndef ladegeraet_ser_schulze_included
#define ladegeraet_ser_schulze_included

#include "messwert.h"
#include "optionen.h"
#include "ladegeraet.h"
#include "ladegeraet_ser.h"
#include "ladegeraet_ser_schulze.h"

class ladegeraet_ser_schulze : public ladegeraet_ser
{
  public:
	// Das Ladegeraet wird geoeffnet. Die Angaben aus den Optionen sind zu beruecksichtigen
    ladegeraet_ser_schulze( optionen *o ) : ladegeraet_ser(o)
    {
      ladegeraet_ser_schulze_init(o); 
    };
     	// Ladegeraet wird geschlossen, z.B. bei Programmende
    ~ladegeraet_ser_schulze( void );

    virtual messwert *read_byte( int *akkunr,char c );

  private:
    void ladegeraet_ser_schulze_init(optionen *o);
    char linebuffer[100];
    int linebuffer_pos;

};

#endif

