//-----------------------------------------------------------------------
// Objekt fuer das Verwalten der Programmeinstellungen
//-----------------------------------------------------------------------
#include <stdio.h>
#include "optionen.h"
#include "qstring.h"
#include "qtstream.h"
#include "qdir.h"


void optionen::sichern( void )  // sichern der Optionen
{
  QString h = QDir::homeDirPath();
  QFile f( h + "/.lader");     // im Homeverzeichnis die Datei ".lader"
  if ( f.open(IO_WriteOnly) )
  {
     QTextStream t( &f );
     t << serpath << " " << welcher_lader;
     f.close();
  }
}

void optionen::laden( void )    // Laden der Optionen aus fest definiertem File
{
  QString h = QDir::homeDirPath();
  QFile f( h + "/.lader"); 
  if ( f.open(IO_ReadOnly) )
  {
     QTextStream t( &f );
     t >> serpath >> ws >> welcher_lader;
     f.close();
  }
}

